function LIK = DiffuseLikelihood2(T,R,Q,Pinf,Pstar,Y,trend,pp,mm,start)
% stephane.adjemian@cepremap.cnrs.fr [07-19-2004]
%
% Same as DiffuseLikelihoodH2.m, without measurement error.
global bayestopt_
  
mf = bayestopt_.mf;
smpl = size(Y,2); % to be verified MJ
a      = zeros(mm,1);
dF = 1;
QQ     = R*Q*transpose(R);
t      = 0;
lik    = zeros(smpl+1,1);
lik(smpl+1,1) = smpl*pp*log(2*pi);%% minus two times the log-likelihood
notsteady     = 1;
crit          = 10^(-12);
reste         = 0;
while rank(Pinf) & t < smpl
	t      = t+1;
    v  	   = Y(:,t)-a(mf)-trend(:,t);
    Fstar  = Pstar(mf,mf);
	iFstar = inv(Fstar);
	lik(t) = log(det(Fstar))+transpose(v)*iFstar*v;
	Kstar  = Pstar(:,mf)*iFstar;	%% premultiplication by the transition matrix T is removed (stephane)
	Pstar  = T*(Pstar-Pstar(:,mf)*transpose(Kstar))*transpose(T)+QQ;
    Pinf   = T*Pinf*transpose(T);
    a      = T*(a+Kstar*v);
end

if t == smpl
  error(['There isn''t enough information to estimate the initial' ...
	 ' conditions of the nonstationary variables']);
end
	 
while notsteady & t < smpl
	t = t+1;
    v         = Y(:,t)-a(mf)-trend(:,t);
    F         = Pstar(mf,mf);
	dF		  = det(F);	
	iF		  = inv(F);
	lik(t)    = log(dF) + transpose(v)*iF*v;
    K         = Pstar(:,mf)*iF;	%% premultiplication by the transition matrix T is removed (stephane)
    a         = T*(a + K*v);
    oldPstar  = Pstar;
    Pstar     = T*(Pstar-Pstar(:,mf)*transpose(K))*transpose(T)+QQ;
    notsteady = ~(max(max(abs(Pstar-oldPstar)))<crit);
end
reste  = smpl-t;
while t < smpl
	t      = t+1;
	v      = Y(:,t)-a(mf)-trend(:,t);
	lik(t) = transpose(v)*iF*v;
	a      = T*(a+K*v);
end
lik(t) = lik(t) + reste*log(dF);
LIK    = .5*(sum(lik(start:end))-(start-1)*lik(smpl+1)/smpl);% Minus the log-likelihood.

