% Program calculating the non-l;inear constraint for posterior mximisation
% M. Ratto
% adapted from mj_optmumlik.m
%------------------------------------------------------------------------------
%------------------------------------------------------------------------------
function [c, ceq] = mr_nlincon(xparam1,gend,rawdata,algo);


global bayestopt_ exo_nbr dr_ estim_params_ Sigma_e_ options_ xparam_test ...
    dr1_test_ trend_coeff_ 


c=0;
ceq=0;

xparam_test = xparam1;
cost_flag = 1;
if options_.mode_compute ~= 1 && any(xparam1 < bayestopt_.lb)
  k = find(xparam1 < bayestopt_.lb);
  c = sum(bayestopt_.lb(k)-xparam1(k));
  cost_flag = 0;
  return;
end
if options_.mode_compute ~= 1 && any(xparam1 > bayestopt_.ub)
  k = find(xparam1 > bayestopt_.ub);
  c = sum(xparam1(k)-bayestopt_.ub(k));
  cost_flag = 0;
  return;
end

nobs = size(options_.varobs,1);

q = Sigma_e_;
for i=1:estim_params_.nvx
  k =estim_params_.var_exo(i,1);
  q(k,k) = xparam1(i)*xparam1(i);
end

offset = estim_params_.nvx;
h = zeros(nobs,nobs);
for i=1:estim_params_.nvn
  k =estim_params_.var_endo(i,1);
  h(k,k) = xparam1(i+offset)*xparam1(i+offset);
end

offset = offset+estim_params_.nvn;
for i=1:estim_params_.ncx
  k1 =estim_params_.corrx(i,1);
  k2 =estim_params_.corrx(i,2);
  q(k1,k2) = xparam1(i+offset)*sqrt(q(k1,k1)*q(k2,k2));
  q(k2,k1) = q(k1,k2);
end

offset = offset+estim_params_.ncx;
for i=1:estim_params_.ncn
  k1 =estim_params_.corrn(i,1);
  k2 =estim_params_.corrn(i,2);
  h(k1,k2) = xparam1(i+offset)*sqrt(h(k1,k1)*h(k2,k2));
  h(k2,k1) = h(k1,k2);
end

offset = offset+estim_params_.ncn;
for i=1:estim_params_.np
   assignin('base',deblank(estim_params_.param_names(i,:)),xparam1(i+offset));
end
Sigma_e_=q;

%------------------------------------------------------------------------------
% 2. call model setup & reduction program
%------------------------------------------------------------------------------

[A,B,ys] = dynare_resolve;

if dr1_test_(1) == 1
    c = abs(dr1_test_(2));
    cost_flag = 0;
    return;
elseif dr1_test_(1) == 2;
    c = abs(dr1_test_(2));
    cost_flag = 0;
    return;
elseif dr1_test_(1) == 3;
    c = abs(dr1_test_(2));
    cost_flag = 0;
    return;    
end

% 11/18/03 MJ changed input parameters for priordens()
